<template>
  <transition name="fade">
    <div v-if="isShow" class="confirm">
      <div class="confirm-outer" @click="close()" />
      <transition name="bounceIn">
        <div v-if="isShow" class="confirm-wrapper">
          <div @click="close()" class="confirm-wrapper__close">
            <i class="bx bx-x"></i>
          </div>
          <div class="confirm-content">
            <p v-if="dialog.title" v-html="dialog.title"></p>
            <span v-if="dialog.message" v-html="dialog.message"></span>
            <div class="confirm-buttons">
              <button
                v-if="dialog.button.no"
                @click.stop="(e) => handleClickButton(false)"
                type="button"
                class="confirm-buttons__left"
              >
                {{ dialog.button.no }}
              </button>

              <button
                v-if="dialog.button.yes"
                @click.stop="(e) => handleClickButton(true)"
                type="button"
                class="confirm-buttons__right"
              >
                {{ dialog.button.yes }}
              </button>
            </div>
          </div>
        </div>
      </transition>
    </div>
  </transition>
</template>

<script>
import ConfirmEvents from "./events";

export default {
  name: "confirm",
  data() {
    return {
      isShow: false,

      dialog: {
        title: "",
        message: "",
        button: {},
      },

      params: {},
    };
  },
  methods: {
    handleClickButton(confirm) {
      this.isShow = false;
      if (this.params.callback) {
        this.params.callback(confirm);
      }
    },
    open(params) {
      this.resetState();
      this.params = params;
      this.isShow = true;
      Object.entries(params).forEach((param) => {
        if (typeof param[1] == typeof this.dialog[param[0]]) {
          this.dialog[param[0]] = param[1];
        }
      });
    },
    close() {
      this.isShow = false;
      if (this.params.callback) {
        this.params.callback(false);
      }
    },
    resetState() {
      this.dialog = {
        title: "",
        message: "",
        button: {},
        callback: () => {},
      };
    },
  },
  mounted() {
    if (!document) return;
    ConfirmEvents.$on("open", this.open);
    ConfirmEvents.$on("close", this.close);
  },
};
</script>

<style lang="scss">
.confirm {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  z-index: 102;
  max-height: 100vh;
  overflow: hidden;
  display: flex;
  justify-content: center;
  align-items: center;
  &-outer {
    position: fixed;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background: rgba(0, 0, 0, 0.2);
    backdrop-filter: saturate(180%) blur(15px);
  }

  &-wrapper {
    background: #fff;
    position: relative;
    border-radius: 20px;
    transition: all 0.25s ease;
    box-shadow: 0 5px 30px 0 rgba(0, 0, 0, 0.5);
    margin: auto;
    transition: all ease 0.6s;
    z-index: 11;
  }
  &-wrapper__close {
    box-shadow: 0 5px 20px 0 rgba(0, 0, 0, 0.1);
    border-radius: 12px;
    background: #fff;
    cursor: pointer;
    position: absolute;
    right: -9px;
    top: -9px;
    padding: 15px;
    display: flex;
    justify-content: center;
    align-items: center;
    z-index: 200;
  }

  &-content {
    overflow: auto;
    width: 650px;
    height: 100%;
    position: relative;
    max-width: 350px;
    max-height: 650px;
    border-radius: 20px;
    overflow-x: hidden;
    @include less-than(tablet) {
      max-width: 350px;
    }
  }

  &-buttons {
    display: flex;
    border-top: 1px solid #ccc;
  }

  p {
    font-size: 20px;
    font-family: "Montserrat-Bold";
    text-align: center;
    margin-top: 20px;
    margin-bottom: 10px;
    display: block;
  }
  span {
    display: block;
    text-align: center;
    margin-bottom: 20px;
    padding: 0 30px;
  }

  button {
    flex: 1;
    padding: 20px;
    background-color: #fff;
    outline: none;
    transition: all ease 0.3s;
    font-weight: 800;
    &:hover {
      background-color: rgba(184, 207, 240, 0.1215686275);
    }
  }

  &-buttons__left {
    border-right: 1px solid #ccc;
  }
  &-buttons__right {
    border-right: 1px solid #ccc;
    color: red;
  }
}
.confirm .bounceIn-enter-active {
  animation: bounceIn 0.3s;
}
.bounceIn-leave-active {
  animation: bounceIn 0.3s reverse;
}

.fade-enter-active {
  animation: fade 0.15s;
}
.fade-leave-active {
  animation: fade 0.15s reverse;
}

@keyframes fade {
  0% {
    opacity: 0;
  }
  50% {
    opacity: 0.5;
  }
  100% {
    opacity: 1;
  }
}

@keyframes bounceIn {
  0% {
    opacity: 0;
    transform: scale(0.7);
  }
  100% {
    transform: scale(1);
  }
}
</style>
